searchData={"items":[{"type":"module","title":"CKEditor5","doc":"The main module for CKEditor 5 integration in Phoenix Framework.","ref":"CKEditor5.html"},{"type":"function","title":"CKEditor5.cloud_assets/1","doc":"See  CKEditor5.Components.Cloud.Assets.render/1 .","ref":"CKEditor5.html#cloud_assets/1"},{"type":"function","title":"CKEditor5.editable/1","doc":"See  CKEditor5.Components.Editable.render/1 .","ref":"CKEditor5.html#editable/1"},{"type":"function","title":"CKEditor5.editor/1","doc":"See  CKEditor5.Components.Editor.render/1 .","ref":"CKEditor5.html#editor/1"},{"type":"function","title":"CKEditor5.ui_part/1","doc":"See  CKEditor5.Components.UIPart.render/1 .","ref":"CKEditor5.html#ui_part/1"},{"type":"function","title":"CKEditor5.version/0","doc":"","ref":"CKEditor5.html#version/0"},{"type":"module","title":"CKEditor5.Cloud","doc":"Represents the Cloud configuration for a CKEditor 5 preset.","ref":"CKEditor5.Cloud.html"},{"type":"function","title":"CKEditor5.Cloud.build_struct/1","doc":"Builds a Cloud struct with default values, allowing for overrides.","ref":"CKEditor5.Cloud.html#build_struct/1"},{"type":"function","title":"CKEditor5.Cloud.defaults/0","doc":"Returns default values for Cloud configuration.","ref":"CKEditor5.Cloud.html#defaults/0"},{"type":"function","title":"CKEditor5.Cloud.merge/2","doc":"Merges the current Cloud configuration with the provided overrides.","ref":"CKEditor5.Cloud.html#merge/2"},{"type":"function","title":"CKEditor5.Cloud.parse/1","doc":"Parses a map into a Cloud struct.\nReturns {:ok, %Cloud{}} if valid, {:error, reason} if invalid.","ref":"CKEditor5.Cloud.html#parse/1"},{"type":"function","title":"CKEditor5.Cloud.parse!/1","doc":"Parses a map into a Cloud struct.\nReturns %Cloud{} if valid, raises an error if invalid.","ref":"CKEditor5.Cloud.html#parse!/1"},{"type":"function","title":"CKEditor5.Cloud.s/0","doc":"Defines the schema for a raw Cloud configuration map.","ref":"CKEditor5.Cloud.html#s/0"},{"type":"type","title":"CKEditor5.Cloud.t/0","doc":"","ref":"CKEditor5.Cloud.html#t:t/0"},{"type":"module","title":"CKEditor5.Cloud.AssetPackage","doc":"Represents a package of JavaScript and CSS assets for CKEditor 5 Cloud.","ref":"CKEditor5.Cloud.AssetPackage.html"},{"type":"type","title":"CKEditor5.Cloud.AssetPackage.css_asset/0","doc":"","ref":"CKEditor5.Cloud.AssetPackage.html#t:css_asset/0"},{"type":"type","title":"CKEditor5.Cloud.AssetPackage.js_asset/0","doc":"","ref":"CKEditor5.Cloud.AssetPackage.html#t:js_asset/0"},{"type":"function","title":"CKEditor5.Cloud.AssetPackage.merge/2","doc":"Merges the current asset package with another asset package, combining js and css arrays.","ref":"CKEditor5.Cloud.AssetPackage.html#merge/2"},{"type":"module","title":"CKEditor5.Cloud.AssetPackage.CKBox","doc":"Generates asset package URLs for CKBox.","ref":"CKEditor5.Cloud.AssetPackage.CKBox.html"},{"type":"function","title":"CKEditor5.Cloud.AssetPackage.CKBox.build_package/2","doc":"Creates URLs for CKBox JavaScript and CSS files.","ref":"CKEditor5.Cloud.AssetPackage.CKBox.html#build_package/2"},{"type":"module","title":"CKEditor5.Cloud.AssetPackage.CKEditor5","doc":"Generates asset package URLs for CKEditor5 core files.","ref":"CKEditor5.Cloud.AssetPackage.CKEditor5.html"},{"type":"function","title":"CKEditor5.Cloud.AssetPackage.CKEditor5.build_package/2","doc":"Creates URLs for CKEditor5 core JavaScript and CSS files.","ref":"CKEditor5.Cloud.AssetPackage.CKEditor5.html#build_package/2"},{"type":"module","title":"CKEditor5.Cloud.AssetPackage.CKEditor5PremiumFeatures","doc":"Generates asset package URLs for CKEditor5 Premium Features.","ref":"CKEditor5.Cloud.AssetPackage.CKEditor5PremiumFeatures.html"},{"type":"function","title":"CKEditor5.Cloud.AssetPackage.CKEditor5PremiumFeatures.build_package/2","doc":"Creates URLs for CKEditor5 Premium Features JavaScript and CSS files.","ref":"CKEditor5.Cloud.AssetPackage.CKEditor5PremiumFeatures.html#build_package/2"},{"type":"module","title":"CKEditor5.Cloud.AssetPackage.JSAsset","doc":"Represents a JavaScript asset in an asset package.","ref":"CKEditor5.Cloud.AssetPackage.JSAsset.html"},{"type":"type","title":"CKEditor5.Cloud.AssetPackage.JSAsset.t/0","doc":"","ref":"CKEditor5.Cloud.AssetPackage.JSAsset.html#t:t/0"},{"type":"module","title":"CKEditor5.Cloud.AssetPackageBuilder","doc":"Module responsible for building asset packages for CKEditor5 cloud resources.\n\nThis module creates the necessary asset packages for different CKEditor5 components\nbased on the cloud configuration, including the main editor, premium features, and CKBox.","ref":"CKEditor5.Cloud.AssetPackageBuilder.html"},{"type":"function","title":"CKEditor5.Cloud.AssetPackageBuilder.build/1","doc":"Builds the complete asset package for the given cloud configuration.","ref":"CKEditor5.Cloud.AssetPackageBuilder.html#build/1"},{"type":"module","title":"CKEditor5.Cloud.UrlBuilder","doc":"Builds URLs for CKEditor 5 Cloud resources.","ref":"CKEditor5.Cloud.UrlBuilder.html"},{"type":"function","title":"CKEditor5.Cloud.UrlBuilder.build_url/1","doc":"Builds the URL for a specific CKEditor 5 Cloud resource.\nAccepts multiple path segments that will be joined with \"/\".","ref":"CKEditor5.Cloud.UrlBuilder.html#build_url/1"},{"type":"module","title":"CKEditor5.Components.Cloud.Assets","doc":"A component for rendering all necessary CKEditor 5 assets from the cloud.\nThis includes the import map, stylesheets, and UMD scripts.\n\nIt's a convenient way to include all required assets with a single component.\nThis component composes other cloud components to provide a unified interface.","ref":"CKEditor5.Components.Cloud.Assets.html"},{"type":"module","title":"⚠️ Warning - CKEditor5.Components.Cloud.Assets","doc":"This component can only be used if the preset has the Cloud option enabled, which is not available\nunder the GPL license key. You must specify your own Cloud or use a commercial license to utilize\nthis feature.","ref":"CKEditor5.Components.Cloud.Assets.html#module-warning"},{"type":"function","title":"CKEditor5.Components.Cloud.Assets.render/1","doc":"Renders all the assets by composing individual cloud components.\nAccepts a `:preset` assign to specify which preset's assets to use.","ref":"CKEditor5.Components.Cloud.Assets.html#render/1"},{"type":"function","title":"Attributes - CKEditor5.Components.Cloud.Assets.render/1","doc":"* `preset` (`:string`) - The name of the preset to use. Defaults to `\"default\"`.\n* `nonce` (`:string`) - The CSP nonce to use for the script and link tags. Defaults to `nil`.","ref":"CKEditor5.Components.Cloud.Assets.html#render/1-attributes"},{"type":"module","title":"CKEditor5.Components.Cloud.Importmap","doc":"A component for rendering an import map in Phoenix.\nThis component generates a script tag with type \"importmap\" containing an empty imports object.\nIt can be used to define module imports for JavaScript in a Phoenix application.","ref":"CKEditor5.Components.Cloud.Importmap.html"},{"type":"module","title":"⚠️ Warning - CKEditor5.Components.Cloud.Importmap","doc":"Import maps can only be used if the preset has the Cloud option enabled, which is not available\nunder the GPL license key. You must specify your own Cloud or use a commercial license to utilize\nthis feature.","ref":"CKEditor5.Components.Cloud.Importmap.html#module-warning"},{"type":"function","title":"CKEditor5.Components.Cloud.Importmap.render/1","doc":"Renders the import map script tag.\nThis component does not take any specific assigns, but it can be customized with a `:preset` assign\nto specify which preset's import map to use.","ref":"CKEditor5.Components.Cloud.Importmap.html#render/1"},{"type":"function","title":"Attributes - CKEditor5.Components.Cloud.Importmap.render/1","doc":"* `preset` (`:string`) - The name of the preset to use. Defaults to `\"default\"`.\n* `nonce` (`:string`) - The CSP nonce to use for the script tag. Defaults to `nil`.","ref":"CKEditor5.Components.Cloud.Importmap.html#render/1-attributes"},{"type":"module","title":"CKEditor5.Components.Cloud.ModulePreload","doc":"A component for rendering module_preload link tags in Phoenix.\nThis component generates link tags with rel=\"modulepreload\" for all modules in the import map.\nIt helps browsers preload ES modules, improving performance by downloading dependencies\nbefore they are actually needed.","ref":"CKEditor5.Components.Cloud.ModulePreload.html"},{"type":"function","title":"CKEditor5.Components.Cloud.ModulePreload.module_preload/1","doc":"Renders module_preload link tags for all modules in the import map.\nThis helps browsers preload ES modules, improving performance by downloading\ndependencies before they are actually needed.","ref":"CKEditor5.Components.Cloud.ModulePreload.html#module_preload/1"},{"type":"function","title":"Attributes - CKEditor5.Components.Cloud.ModulePreload.module_preload/1","doc":"* `preset` (`:string`) - The name of the preset to use. Defaults to `\"default\"`.\n* `nonce` (`:string`) - The CSP nonce to use for the script tag. Defaults to `nil`.","ref":"CKEditor5.Components.Cloud.ModulePreload.html#module_preload/1-attributes"},{"type":"module","title":"CKEditor5.Components.Cloud.Stylesheets","doc":"A component for rendering stylesheet link tags in Phoenix.\nThis component generates link tags for CSS stylesheets.\nIt can be used to load CKEditor 5 styles in a Phoenix application.","ref":"CKEditor5.Components.Cloud.Stylesheets.html"},{"type":"module","title":"⚠️ Warning - CKEditor5.Components.Cloud.Stylesheets","doc":"This component can only be used if the preset has the Cloud option enabled, which is not available\nunder the GPL license key. You must specify your own Cloud or use a commercial license to utilize\nthis feature.","ref":"CKEditor5.Components.Cloud.Stylesheets.html#module-warning"},{"type":"function","title":"CKEditor5.Components.Cloud.Stylesheets.render/1","doc":"Renders the stylesheet link tags.\nThis component can be customized with a `:preset` assign\nto specify which preset's stylesheets to use.","ref":"CKEditor5.Components.Cloud.Stylesheets.html#render/1"},{"type":"function","title":"Attributes - CKEditor5.Components.Cloud.Stylesheets.render/1","doc":"* `preset` (`:string`) - The name of the preset to use. Defaults to `\"default\"`.\n* `nonce` (`:string`) - The CSP nonce to use for the link tags. Defaults to `nil`.","ref":"CKEditor5.Components.Cloud.Stylesheets.html#render/1-attributes"},{"type":"module","title":"CKEditor5.Components.Cloud.UmdScripts","doc":"A component for rendering UMD script tags in Phoenix.\nThis component generates script tags for UMD modules.\nIt can be used to load CKEditor 5 builds in a Phoenix application.","ref":"CKEditor5.Components.Cloud.UmdScripts.html"},{"type":"module","title":"⚠️ Warning - CKEditor5.Components.Cloud.UmdScripts","doc":"This component can only be used if the preset has the Cloud option enabled, which is not available\nunder the GPL license key. You must specify your own Cloud or use a commercial license to utilize\nthis feature.","ref":"CKEditor5.Components.Cloud.UmdScripts.html#module-warning"},{"type":"function","title":"CKEditor5.Components.Cloud.UmdScripts.render/1","doc":"Renders the UMD script tags.\nThis component can be customized with a `:preset` assign\nto specify which preset's scripts to use.","ref":"CKEditor5.Components.Cloud.UmdScripts.html#render/1"},{"type":"function","title":"Attributes - CKEditor5.Components.Cloud.UmdScripts.render/1","doc":"* `preset` (`:string`) - The name of the preset to use. Defaults to `\"default\"`.\n* `nonce` (`:string`) - The CSP nonce to use for the script tags. Defaults to `nil`.","ref":"CKEditor5.Components.Cloud.UmdScripts.html#render/1-attributes"},{"type":"module","title":"CKEditor5.Components.Editable","doc":"Live View component for rendering an editable area in CKEditor 5.\nIt may be used with decoupled editors or multiroot editors.","ref":"CKEditor5.Components.Editable.html"},{"type":"function","title":"CKEditor5.Components.Editable.render/1","doc":"","ref":"CKEditor5.Components.Editable.html#render/1"},{"type":"function","title":"Attributes - CKEditor5.Components.Editable.render/1","doc":"* `id` (`:string`) - The ID of the component. If not provided, it will be generated from the\n  `editor_id` and `name` attributes.\n\n* `root` (`:string`) (required) - The name of the root that is associated with this editable area. Editor may contain multiple\n  roots which correspond to separate documents (or sections) of the editor. This name will be used\n  as a key to identify the editable area in the editor's data.\n\n* `editor_id` (`:string`) - The ID of the editor instance this editable belongs to. If not provided,\n  the first editor in the page will be used.\n\n  Defaults to `nil`.\n* `name` (`:string`) - The name of the input field that will be used to submit the content.\n  If not provided, it will be derived from the `:field` attribute when available.\n  This is useful for form integration, allowing the content to be submitted as part of a form.\n\n  Defaults to `nil`.\n* `form` (`:any`) - The `Phoenix.HTML.Form` for form integration. Defaults to `nil`.\n* `field` (`Phoenix.HTML.FormField`) - The `Phoenix.HTML.FormField` for form integration. Defaults to `nil`.\n* `value` (`:string`) - The initial value for the content. This will be set when the component is initialized.\n  If not specified, it will default to an empty string.\n\n  Defaults to `\"\"`.\n* `required` (`:boolean`) - Marks the input as required. This will be used to validate the content when the form is submitted. Defaults to `false`.\n* Global attributes are accepted.","ref":"CKEditor5.Components.Editable.html#render/1-attributes"},{"type":"module","title":"CKEditor5.Components.Editor","doc":"LiveView component for CKEditor 5 integration in Phoenix Framework.\n\nThis module provides the necessary functionality to render and manage\nCKEditor 5 instances within Phoenix LiveView applications.","ref":"CKEditor5.Components.Editor.html"},{"type":"function","title":"CKEditor5.Components.Editor.render/1","doc":"Renders the CKEditor 5 component in a LiveView.","ref":"CKEditor5.Components.Editor.html#render/1"},{"type":"function","title":"Attributes - CKEditor5.Components.Editor.render/1","doc":"* `id` (`:string`) - The ID for the editor instance.\n* `preset` (`:string`) - The name of the preset to use. Defaults to `\"default\"`.\n* `editable_height` (`:string`) - The height of the editable area (e.g., \"300px\"). If not provided, the height will be determined by the editor's content. Defaults to `nil`.\n* `type` (`:string`) - The type of the editor. Overrides the type from the preset. Defaults to `nil`.\n* `name` (`:string`) - The name of the input field that will be used to submit the content.\n  If not provided, it will be derived from the `:field` attribute when available.\n  This is useful for form integration, allowing the content to be submitted as part of a form.\n\n  Defaults to `nil`.\n* `form` (`:any`) - The `Phoenix.HTML.Form` for form integration. Defaults to `nil`.\n* `field` (`Phoenix.HTML.FormField`) - The `Phoenix.HTML.FormField` for form integration. Defaults to `nil`.\n* `value` (`:string`) - The initial value for the content. This will be set when the component is initialized.\n  If not specified, it will default to an empty string.\n\n  Defaults to `\"\"`.\n* `required` (`:boolean`) - Marks the input as required. This will be used to validate the content when the form is submitted. Defaults to `false`.\n* Global attributes are accepted.","ref":"CKEditor5.Components.Editor.html#render/1-attributes"},{"type":"module","title":"CKEditor5.Components.Editor.Assigns","doc":"Handles assigns processing for the Editor component.","ref":"CKEditor5.Components.Editor.Assigns.html"},{"type":"function","title":"CKEditor5.Components.Editor.Assigns.prepare/1","doc":"Prepares the assigns for the editor component by processing and validating them.","ref":"CKEditor5.Components.Editor.Assigns.html#prepare/1"},{"type":"module","title":"CKEditor5.Components.Editor.AttributeValidator","doc":"Validates attributes for different editor types in the Editor component.","ref":"CKEditor5.Components.Editor.AttributeValidator.html"},{"type":"function","title":"CKEditor5.Components.Editor.AttributeValidator.validate_for_editor_type/1","doc":"Validates attributes based on the editor type.","ref":"CKEditor5.Components.Editor.AttributeValidator.html#validate_for_editor_type/1"},{"type":"module","title":"CKEditor5.Components.Editor.PresetHandler","doc":"Handles preset loading and type overriding for the Editor component.","ref":"CKEditor5.Components.Editor.PresetHandler.html"},{"type":"function","title":"CKEditor5.Components.Editor.PresetHandler.process_preset/1","doc":"Loads the preset configuration from the preset name and applies type override if specified.","ref":"CKEditor5.Components.Editor.PresetHandler.html#process_preset/1"},{"type":"module","title":"CKEditor5.Components.Editor.ValueNormalizer","doc":"Normalizes and transforms values for the Editor component.","ref":"CKEditor5.Components.Editor.ValueNormalizer.html"},{"type":"function","title":"CKEditor5.Components.Editor.ValueNormalizer.normalize_values/1","doc":"Normalizes various values in the assigns.","ref":"CKEditor5.Components.Editor.ValueNormalizer.html#normalize_values/1"},{"type":"module","title":"CKEditor5.Components.HiddenInput","doc":"LiveView component for rendering a hidden input field.","ref":"CKEditor5.Components.HiddenInput.html"},{"type":"function","title":"CKEditor5.Components.HiddenInput.render/1","doc":"Renders a hidden input field with the specified attributes.","ref":"CKEditor5.Components.HiddenInput.html#render/1"},{"type":"function","title":"Attributes - CKEditor5.Components.HiddenInput.render/1","doc":"* `id` (`:string`) (required) - The ID of the hidden input.\n* `name` (`:string`) (required) - The name of the hidden input.\n* `value` (`:string`) - The value of the hidden input. Defaults to `\"\"`.\n* `required` (`:boolean`) - Whether the input is required. Defaults to `false`.","ref":"CKEditor5.Components.HiddenInput.html#render/1-attributes"},{"type":"module","title":"CKEditor5.Components.UIPart","doc":"Live View component for rendering a UI part of CKEditor 5, like a toolbar or a menubar.\nIt may be used with decoupled editors.","ref":"CKEditor5.Components.UIPart.html"},{"type":"function","title":"CKEditor5.Components.UIPart.render/1","doc":"","ref":"CKEditor5.Components.UIPart.html#render/1"},{"type":"function","title":"Attributes - CKEditor5.Components.UIPart.render/1","doc":"* `name` (`:string`) (required) - The name of the UI part. This will be used to identify the UI part\n  in the editor configuration. E.g. \"toolbar\", \"menubar\".\n\n* `editor_id` (`:string`) - The ID of the editor instance this UI part belongs to. If not provided,\n  the first editor in the page will be used.\n\n  Defaults to `nil`.\n* Global attributes are accepted.","ref":"CKEditor5.Components.UIPart.html#render/1-attributes"},{"type":"module","title":"CKEditor5.Form","doc":"Common helper functions for CKEditor5 form components.","ref":"CKEditor5.Form.html"},{"type":"function","title":"CKEditor5.Form.assign_form_fields/1","doc":"Assigns form fields if the `form` and `field` attributes are provided.\nThis function checks if the `form` is present and if the `field` is an atom.\nIt then retrieves the input name and value from the form and assigns them to the assigns map.","ref":"CKEditor5.Form.html#assign_form_fields/1"},{"type":"macro","title":"CKEditor5.Form.form_attrs/0","doc":"Defines form-related attributes that are commonly used in CKEditor5 components.\nThis includes name, form, field, value, and required attributes for form integration.","ref":"CKEditor5.Form.html#form_attrs/0"},{"type":"module","title":"CKEditor5.Helpers","doc":"Common helper functions for CKEditor5 components.","ref":"CKEditor5.Helpers.html"},{"type":"function","title":"CKEditor5.Helpers.assign_id_if_missing/2","doc":"Assigns a unique ID if one is not already present in assigns.\nGenerates a random UUID-based ID only when :id key is missing.","ref":"CKEditor5.Helpers.html#assign_id_if_missing/2"},{"type":"function","title":"CKEditor5.Helpers.is_semver_version?/1","doc":"Checks if a given version string is in semantic versioning format (e.g., \"1.0.0\").","ref":"CKEditor5.Helpers.html#is_semver_version?/1"},{"type":"function","title":"CKEditor5.Helpers.serialize_styles_map/1","doc":"Serializes a map of styles into a CSS string.\nConverts a map of styles into a string suitable for inline CSS.\nExample: %{color: \"red\", \"font-size\": \"16px\"} becomes \"color: red; font-size: 16px\".","ref":"CKEditor5.Helpers.html#serialize_styles_map/1"},{"type":"module","title":"CKEditor5.License","doc":"Provides functionality to manage CKEditor 5 license keys.","ref":"CKEditor5.License.html"},{"type":"function","title":"CKEditor5.License.env_license_or_gpl/0","doc":"Returns the default license key from environment variable or \"GPL\".","ref":"CKEditor5.License.html#env_license_or_gpl/0"},{"type":"function","title":"CKEditor5.License.format_key/1","doc":"Formats the license key for safe display by truncating long keys.","ref":"CKEditor5.License.html#format_key/1"},{"type":"function","title":"CKEditor5.License.gpl/0","doc":"Creates a new GPL license struct.\nThis license is compatible with all distribution channels.","ref":"CKEditor5.License.html#gpl/0"},{"type":"function","title":"CKEditor5.License.new/1","doc":"Creates a new License struct with the given license key.\nAutomatically extracts the distribution channel from the license key.\nReturns {:ok, %License{}} for valid keys or {:error, error} for invalid keys.","ref":"CKEditor5.License.html#new/1"},{"type":"type","title":"CKEditor5.License.t/0","doc":"","ref":"CKEditor5.License.html#t:t/0"},{"type":"module","title":"CKEditor5.Preset","doc":"Represents a CKEditor 5 preset configuration.","ref":"CKEditor5.Preset.html"},{"type":"function","title":"CKEditor5.Preset.configured_cloud?/1","doc":"Checks if the preset has a Cloud configuration.\nReturns true if the cloud field is not nil, false otherwise.","ref":"CKEditor5.Preset.html#configured_cloud?/1"},{"type":"function","title":"CKEditor5.Preset.merge/2","doc":"Merges the current preset configuration with the provided overrides.","ref":"CKEditor5.Preset.html#merge/2"},{"type":"function","title":"CKEditor5.Preset.of_type/2","doc":"Sets the type of the preset.","ref":"CKEditor5.Preset.html#of_type/2"},{"type":"type","title":"CKEditor5.Preset.t/0","doc":"","ref":"CKEditor5.Preset.html#t:t/0"},{"type":"module","title":"CKEditor5.Preset.CloudCompatibilityChecker","doc":"Enforces business rules and compatibility constraints for CKEditor5 presets.\nSpecifically handles Cloud Distribution Channel licensing requirements and configuration validation.","ref":"CKEditor5.Preset.CloudCompatibilityChecker.html"},{"type":"function","title":"CKEditor5.Preset.CloudCompatibilityChecker.assign_default_cloud_config/1","doc":"Checks if the preset's Cloud configuration is valid based on the license type.","ref":"CKEditor5.Preset.CloudCompatibilityChecker.html#assign_default_cloud_config/1"},{"type":"function","title":"CKEditor5.Preset.CloudCompatibilityChecker.ensure_cloud_configured!/1","doc":"Ensures that a preset has Cloud configuration when required.","ref":"CKEditor5.Preset.CloudCompatibilityChecker.html#ensure_cloud_configured!/1"},{"type":"module","title":"CKEditor5.Preset.EditorType","doc":"Defines the available editor types for CKEditor5 presets.\nThis module provides a schema for the editor types and includes a function to validate them.","ref":"CKEditor5.Preset.EditorType.html"},{"type":"function","title":"CKEditor5.Preset.EditorType.s/0","doc":"","ref":"CKEditor5.Preset.EditorType.html#s/0"},{"type":"function","title":"CKEditor5.Preset.EditorType.single_editing_like?/1","doc":"Checks if the given type is a single editing-like editor.\nSingle editing-like editors are those that allow inline or classic editing modes.","ref":"CKEditor5.Preset.EditorType.html#single_editing_like?/1"},{"type":"function","title":"CKEditor5.Preset.EditorType.valid?/1","doc":"Validates the given editor type against the defined schema.\nReturns `:ok` if the type is valid, or an error tuple if it is not.","ref":"CKEditor5.Preset.EditorType.html#valid?/1"},{"type":"module","title":"CKEditor5.Preset.Parser","doc":"Parses CKEditor5 preset configurations.\nEnsures that the configuration adheres to the expected schema and constraints.","ref":"CKEditor5.Preset.Parser.html"},{"type":"function","title":"CKEditor5.Preset.Parser.parse/1","doc":"Parses and validates a plain map into a CKEditor5 preset configuration.\nReturns {:ok, %Preset{}} if valid, {:error, errors} if invalid.","ref":"CKEditor5.Preset.Parser.html#parse/1"},{"type":"function","title":"CKEditor5.Preset.Parser.parse!/1","doc":"Parses and validates a plain map into a CKEditor5 preset configuration.\nReturns %Preset{} if valid, raises an error if invalid.","ref":"CKEditor5.Preset.Parser.html#parse!/1"},{"type":"function","title":"CKEditor5.Preset.Parser.s/0","doc":"Defines the schema for a preset configuration map.","ref":"CKEditor5.Preset.Parser.html#s/0"},{"type":"module","title":"CKEditor5.Presets","doc":"Provides predefined configurations (presets) for CKEditor 5.","ref":"CKEditor5.Presets.html"},{"type":"function","title":"CKEditor5.Presets.get/1","doc":"Retrieves a preset configuration by name.\n\nReturns `{:ok, preset}` on success, or `{:error, reason}` on failure.","ref":"CKEditor5.Presets.html#get/1"},{"type":"function","title":"CKEditor5.Presets.get!/1","doc":"Retrieves a preset configuration by name, raising an exception on failure.","ref":"CKEditor5.Presets.html#get!/1"},{"type":"module","title":"Playground","doc":"Main playground module providing common functionality and macros for Phoenix components.\n\nThis module defines the shared functionality used across the playground application,\nincluding router, controller, and HTML helper macros.","ref":"Playground.html"},{"type":"function","title":"Playground.controller/0","doc":"","ref":"Playground.html#controller/0"},{"type":"function","title":"Playground.html/0","doc":"","ref":"Playground.html#html/0"},{"type":"function","title":"Playground.live_view/0","doc":"","ref":"Playground.html#live_view/0"},{"type":"function","title":"Playground.router/0","doc":"","ref":"Playground.html#router/0"},{"type":"function","title":"Playground.static_paths/0","doc":"","ref":"Playground.html#static_paths/0"},{"type":"function","title":"Playground.verified_routes/0","doc":"","ref":"Playground.html#verified_routes/0"},{"type":"function","title":"Playground.view/0","doc":"","ref":"Playground.html#view/0"},{"type":"module","title":"Playground.App","doc":"Main application module for the playground.\n\nThis module handles the startup and supervision of the playground application,\nincluding Phoenix PubSub and the endpoint.","ref":"Playground.App.html"},{"type":"function","title":"Playground.App.run/0","doc":"","ref":"Playground.App.html#run/0"},{"type":"function","title":"Playground.App.run_supervisor/0","doc":"","ref":"Playground.App.html#run_supervisor/0"},{"type":"module","title":"Playground.Endpoint","doc":"Phoenix endpoint for the playground application.\n\nThis module configures the web server endpoint, including routing,\nsessions, and static file serving for the playground.","ref":"Playground.Endpoint.html"},{"type":"function","title":"Playground.Endpoint.broadcast/3","doc":"Callback implementation for  Phoenix.Endpoint.broadcast/3 .","ref":"Playground.Endpoint.html#broadcast/3"},{"type":"function","title":"Playground.Endpoint.broadcast!/3","doc":"Callback implementation for  Phoenix.Endpoint.broadcast!/3 .","ref":"Playground.Endpoint.html#broadcast!/3"},{"type":"function","title":"Playground.Endpoint.broadcast_from/4","doc":"Callback implementation for  Phoenix.Endpoint.broadcast_from/4 .","ref":"Playground.Endpoint.html#broadcast_from/4"},{"type":"function","title":"Playground.Endpoint.broadcast_from!/4","doc":"Callback implementation for  Phoenix.Endpoint.broadcast_from!/4 .","ref":"Playground.Endpoint.html#broadcast_from!/4"},{"type":"function","title":"Playground.Endpoint.call/2","doc":"Callback implementation for  Plug.call/2 .","ref":"Playground.Endpoint.html#call/2"},{"type":"function","title":"Playground.Endpoint.child_spec/1","doc":"Returns the child specification to start the endpoint\nunder a supervision tree.","ref":"Playground.Endpoint.html#child_spec/1"},{"type":"function","title":"Playground.Endpoint.config/2","doc":"Returns the endpoint configuration for `key`\n\nReturns `default` if the key does not exist.","ref":"Playground.Endpoint.html#config/2"},{"type":"function","title":"Playground.Endpoint.config_change/2","doc":"Reloads the configuration given the application environment changes.","ref":"Playground.Endpoint.html#config_change/2"},{"type":"function","title":"Playground.Endpoint.host/0","doc":"Returns the host for the given endpoint.","ref":"Playground.Endpoint.html#host/0"},{"type":"function","title":"Playground.Endpoint.init/1","doc":"Callback implementation for  Plug.init/1 .","ref":"Playground.Endpoint.html#init/1"},{"type":"function","title":"Playground.Endpoint.local_broadcast/3","doc":"Callback implementation for  Phoenix.Endpoint.local_broadcast/3 .","ref":"Playground.Endpoint.html#local_broadcast/3"},{"type":"function","title":"Playground.Endpoint.local_broadcast_from/4","doc":"Callback implementation for  Phoenix.Endpoint.local_broadcast_from/4 .","ref":"Playground.Endpoint.html#local_broadcast_from/4"},{"type":"function","title":"Playground.Endpoint.path/1","doc":"Generates the path information when routing to this endpoint.","ref":"Playground.Endpoint.html#path/1"},{"type":"function","title":"Playground.Endpoint.script_name/0","doc":"Generates the script name.","ref":"Playground.Endpoint.html#script_name/0"},{"type":"function","title":"Playground.Endpoint.server_info/1","doc":"Returns the address and port that the server is running on","ref":"Playground.Endpoint.html#server_info/1"},{"type":"function","title":"Playground.Endpoint.start_link/1","doc":"Starts the endpoint supervision tree.\n\nAll other options are merged into the endpoint configuration.","ref":"Playground.Endpoint.html#start_link/1"},{"type":"function","title":"Playground.Endpoint.static_integrity/1","doc":"Generates a base64-encoded cryptographic hash (sha512) to a static file\nin `priv/static`. Meant to be used for Subresource Integrity with CDNs.","ref":"Playground.Endpoint.html#static_integrity/1"},{"type":"function","title":"Playground.Endpoint.static_lookup/1","doc":"Returns a two item tuple with the first item being the `static_path`\nand the second item being the `static_integrity`.","ref":"Playground.Endpoint.html#static_lookup/1"},{"type":"function","title":"Playground.Endpoint.static_path/1","doc":"Generates a route to a static file in `priv/static`.","ref":"Playground.Endpoint.html#static_path/1"},{"type":"function","title":"Playground.Endpoint.static_url/0","doc":"Generates the static URL without any path information.\n\nIt uses the configuration under `:static_url` to generate\nsuch. It falls back to `:url` if `:static_url` is not set.","ref":"Playground.Endpoint.html#static_url/0"},{"type":"function","title":"Playground.Endpoint.struct_url/0","doc":"Generates the endpoint base URL but as a `URI` struct.\n\nIt uses the configuration under `:url` to generate such.\nUseful for manipulating the URL data and passing it to\nURL helpers.","ref":"Playground.Endpoint.html#struct_url/0"},{"type":"function","title":"Playground.Endpoint.subscribe/2","doc":"Callback implementation for  Phoenix.Endpoint.subscribe/2 .","ref":"Playground.Endpoint.html#subscribe/2"},{"type":"function","title":"Playground.Endpoint.unsubscribe/1","doc":"Callback implementation for  Phoenix.Endpoint.unsubscribe/1 .","ref":"Playground.Endpoint.html#unsubscribe/1"},{"type":"function","title":"Playground.Endpoint.url/0","doc":"Generates the endpoint base URL without any path information.\n\nIt uses the configuration under `:url` to generate such.","ref":"Playground.Endpoint.html#url/0"},{"type":"module","title":"Playground.LayoutHtml","doc":"HTML module for the layout of the playground application.","ref":"Playground.LayoutHtml.html"},{"type":"function","title":"Playground.LayoutHtml.__resource__/0","doc":"The resource name, as an atom, for this view","ref":"Playground.LayoutHtml.html#__resource__/0"},{"type":"function","title":"Playground.LayoutHtml.app.html/1","doc":"","ref":"Playground.LayoutHtml.html#app.html/1"},{"type":"function","title":"Playground.LayoutHtml.cke_cloud_assets/1","doc":"See  CKEditor5.Components.Cloud.Assets.render/1 .","ref":"Playground.LayoutHtml.html#cke_cloud_assets/1"},{"type":"function","title":"Playground.LayoutHtml.cke_editable/1","doc":"See  CKEditor5.Components.Editable.render/1 .","ref":"Playground.LayoutHtml.html#cke_editable/1"},{"type":"function","title":"Playground.LayoutHtml.cke_ui_part/1","doc":"See  CKEditor5.Components.UIPart.render/1 .","ref":"Playground.LayoutHtml.html#cke_ui_part/1"},{"type":"function","title":"Playground.LayoutHtml.ckeditor/1","doc":"See  CKEditor5.Components.Editor.render/1 .","ref":"Playground.LayoutHtml.html#ckeditor/1"},{"type":"function","title":"Playground.LayoutHtml.render/2","doc":"Renders the given template locally.","ref":"Playground.LayoutHtml.html#render/2"},{"type":"function","title":"Playground.LayoutHtml.template_not_found/2","doc":"Callback invoked when no template is found.\nBy default it raises but can be customized\nto render a particular template.","ref":"Playground.LayoutHtml.html#template_not_found/2"},{"type":"module","title":"Playground.Live.Classic","doc":"HTML module for the classic editor page of the playground application.","ref":"Playground.Live.Classic.html"},{"type":"function","title":"Playground.Live.Classic.cke_cloud_assets/1","doc":"See  CKEditor5.Components.Cloud.Assets.render/1 .","ref":"Playground.Live.Classic.html#cke_cloud_assets/1"},{"type":"function","title":"Playground.Live.Classic.cke_editable/1","doc":"See  CKEditor5.Components.Editable.render/1 .","ref":"Playground.Live.Classic.html#cke_editable/1"},{"type":"function","title":"Playground.Live.Classic.cke_ui_part/1","doc":"See  CKEditor5.Components.UIPart.render/1 .","ref":"Playground.Live.Classic.html#cke_ui_part/1"},{"type":"function","title":"Playground.Live.Classic.ckeditor/1","doc":"See  CKEditor5.Components.Editor.render/1 .","ref":"Playground.Live.Classic.html#ckeditor/1"},{"type":"function","title":"Playground.Live.Classic.render/1","doc":"Callback implementation for  Phoenix.LiveView.render/1 .","ref":"Playground.Live.Classic.html#render/1"},{"type":"module","title":"Playground.Live.Home","doc":"HTML module for the home page of the playground application.","ref":"Playground.Live.Home.html"},{"type":"function","title":"Playground.Live.Home.render/1","doc":"Callback implementation for  Phoenix.LiveView.render/1 .","ref":"Playground.Live.Home.html#render/1"},{"type":"module","title":"Playground.Live.Multiroot","doc":"HTML module for the multiroot editor page of the playground application.","ref":"Playground.Live.Multiroot.html"},{"type":"function","title":"Playground.Live.Multiroot.cke_cloud_assets/1","doc":"See  CKEditor5.Components.Cloud.Assets.render/1 .","ref":"Playground.Live.Multiroot.html#cke_cloud_assets/1"},{"type":"function","title":"Playground.Live.Multiroot.cke_editable/1","doc":"See  CKEditor5.Components.Editable.render/1 .","ref":"Playground.Live.Multiroot.html#cke_editable/1"},{"type":"function","title":"Playground.Live.Multiroot.cke_ui_part/1","doc":"See  CKEditor5.Components.UIPart.render/1 .","ref":"Playground.Live.Multiroot.html#cke_ui_part/1"},{"type":"function","title":"Playground.Live.Multiroot.ckeditor/1","doc":"See  CKEditor5.Components.Editor.render/1 .","ref":"Playground.Live.Multiroot.html#ckeditor/1"},{"type":"function","title":"Playground.Live.Multiroot.render/1","doc":"Callback implementation for  Phoenix.LiveView.render/1 .","ref":"Playground.Live.Multiroot.html#render/1"},{"type":"module","title":"Playground.Router","doc":"Main router for the playground application.\n\nThis module defines the routing structure and pipelines for handling\nHTTP requests in the playground application.","ref":"Playground.Router.html"},{"type":"function","title":"Playground.Router.api/2","doc":"","ref":"Playground.Router.html#api/2"},{"type":"function","title":"Playground.Router.browser/2","doc":"","ref":"Playground.Router.html#browser/2"},{"type":"function","title":"Playground.Router.call/2","doc":"Callback invoked by Plug on every request.","ref":"Playground.Router.html#call/2"},{"type":"function","title":"Playground.Router.init/1","doc":"Callback required by Plug that initializes the router\nfor serving web requests.","ref":"Playground.Router.html#init/1"},{"type":"exception","title":"CKEditor5.Errors.CloudCannotBeUsedWithLicenseKey","doc":"Exception raised when Cloud cannot be used with the provided license key.","ref":"CKEditor5.Errors.CloudCannotBeUsedWithLicenseKey.html"},{"type":"exception","title":"CKEditor5.Errors.CloudNotConfigured","doc":"Exception raised when Cloud is not configured in the preset.","ref":"CKEditor5.Errors.CloudNotConfigured.html"},{"type":"exception","title":"CKEditor5.Errors.Error","doc":"Represents an error in the CKEditor 5 integration.","ref":"CKEditor5.Errors.Error.html"},{"type":"function","title":"CKEditor5.Errors.Error.exception/2","doc":"Creates a new CKEditor5 error with the given reason.","ref":"CKEditor5.Errors.Error.html#exception/2"},{"type":"exception","title":"CKEditor5.Errors.InvalidCloudConfiguration","doc":"Exception raised when a Cloud configuration is invalid.","ref":"CKEditor5.Errors.InvalidCloudConfiguration.html"},{"type":"exception","title":"CKEditor5.Errors.InvalidLicenseKey","doc":"Exception raised when an invalid license key is provided.","ref":"CKEditor5.Errors.InvalidLicenseKey.html"},{"type":"exception","title":"CKEditor5.Errors.InvalidPreset","doc":"Exception raised when a CKEditor5 preset configuration is invalid.","ref":"CKEditor5.Errors.InvalidPreset.html"},{"type":"exception","title":"CKEditor5.Errors.PresetNotFound","doc":"Exception raised when a CKEditor5 preset is not found.","ref":"CKEditor5.Errors.PresetNotFound.html"},{"type":"extras","title":"CKEditor 5 Phoenix Integration ✨","doc":"# CKEditor 5 Phoenix Integration ✨\n\n[![License: MIT](https://img.shields.io/badge/License-MIT-blue.svg?style=flat-square)](LICENSE)\n[![PRs Welcome](https://img.shields.io/badge/PRs-welcome-green.svg?style=flat-square)](http://makeapullrequest.com)\n![GitHub code size in bytes](https://img.shields.io/github/languages/code-size/mati365/ckeditor5-phoenix?style=flat-square)\n[![GitHub issues](https://img.shields.io/github/issues/mati365/ckeditor5-phoenix?style=flat-square)](https://github.com/Mati365/ckeditor5-phoenix/issues)\n![TS](https://img.shields.io/badge/TypeScript-100%25-brightgreen?logo=typescript&logoColor=white&style=flat-square)\n![Elixir](https://img.shields.io/badge/Elixir-100%25-brightgreen?logo=elixir&logoColor=white&style=flat-square)\n\nCKEditor 5 integration library for Phoenix (Elixir) applications. Provides web components and helper functions for seamless editor integration with support for classic, inline, balloon, and decoupled editor types.\n\n> [!IMPORTANT]\n> This package is unofficial and not maintained by CKSource. For official CKEditor 5 documentation, visit [ckeditor.com](https://ckeditor.com/docs/ckeditor5/latest/). If you encounter any issues in the editor, please report them on the [GitHub repository](https://github.com/ckeditor/ckeditor5/issues).","ref":"readme.html"},{"type":"extras","title":"Installation 🚀 - CKEditor 5 Phoenix Integration ✨","doc":"```bash\n# Under construction. Stay tuned for the upcoming release!\n```","ref":"readme.html#installation"},{"type":"extras","title":"Editor placement 🏗️ - CKEditor 5 Phoenix Integration ✨","doc":"","ref":"readme.html#editor-placement"},{"type":"extras","title":"Classic editor 📝 - CKEditor 5 Phoenix Integration ✨","doc":"The classic editor is the most common type of editor. It provides a toolbar with various formatting options like bold, italic, underline, and link.\n\nIt looks like this:\n\n![CKEditor 5 Classic Editor in Elixir Phoenix application with Menubar](docs/classic-editor-with-toolbar.png)\n\n```heex\n<%!-- In   --%>\n<.cke_cloud_assets />\n\n<%!-- In   --%>'\n<.ckeditor\n  type=\"classic\"\n  value=\" Initial content here \"\n  editable_height=\"300px\"\n/>\n```","ref":"readme.html#classic-editor"},{"type":"extras","title":"Multiroot editor 🌳 - CKEditor 5 Phoenix Integration ✨","doc":"The multiroot editor allows you to create an editor with multiple editable areas. It's useful when you want to create a CMS with multiple editable areas on a single page.\n\n- `ckeditor` component is used to create the editor container. It'll initialize the editor without any editable nor toolbar. The full list of attributes can be found in the [source](lib/components/editor/editor.ex).\n- `cke_editable` component is used to create editable areas within the editor. Each editable area can have its own name and initial value. The full list of attributes can be found in the [source](lib/components/editable.ex).\n\n![CKEditor 5 Multiroot Editor in Elixir Phoenix application](docs/multiroot-editor.png)\n\n```heex\n<%!-- In   --%>\n<.cke_cloud_assets />\n\n<%!-- In   --%>\n<.ckeditor type=\"multiroot\" />\n\n<.cke_ui_part name=\"toolbar\" />\n\n \n  <.cke_editable\n    root=\"header\"\n    value=\" Main Header \"\n    class=\"border border-gray-300\"\n  />\n  <.cke_editable\n    root=\"content\"\n    value=\" Main content area \"\n    class=\"border border-gray-300\"\n  />\n  <.cke_editable\n    root=\"sidebar\"\n    value=\" Sidebar content \"\n    class=\"border border-gray-300\"\n  />\n \n```","ref":"readme.html#multiroot-editor"},{"type":"extras","title":"Inline editor 📝 - CKEditor 5 Phoenix Integration ✨","doc":"Inline editor allows you to create an editor that can be placed inside any element. Keep in mind that inline editor does not work with `textarea` elements so it might be not suitable for all use cases.\n\n![CKEditor 5 Inline Editor in Elixir Phoenix application](docs/inline-editor.png)\n\nIf you want to use an inline editor, you can pass the `type` keyword argument with the value `:inline`:\n\n```heex\n<%!-- In   --%>\n<.cke_cloud_assets />\n\n<%!-- In   --%>\n<.ckeditor\n  type=\"inline\"\n  value=\" Initial content here \"\n  editable_height=\"300px\"\n/>\n```","ref":"readme.html#inline-editor"},{"type":"extras","title":"Package development 🛠️ - CKEditor 5 Phoenix Integration ✨","doc":"In order to run the minimal Phoenix application with CKEditor 5 integration, you need to install the dependencies and run the server:\n\n```bash\nmix playground\n```","ref":"readme.html#package-development"},{"type":"extras","title":"Trademarks 📜 - CKEditor 5 Phoenix Integration ✨","doc":"CKEditor® is a trademark of [CKSource Holding sp. z o.o.](https://cksource.com/) All rights reserved. For more information about the license of CKEditor® please visit [CKEditor's licensing page](https://ckeditor.com/legal/ckeditor-oss-license/).\n\nThis package is not owned by CKSource and does not use the CKEditor® trademark for commercial purposes. It should not be associated with or considered an official CKSource product.","ref":"readme.html#trademarks"},{"type":"extras","title":"License 📜 - CKEditor 5 Phoenix Integration ✨","doc":"This project is licensed under the terms of the [MIT LICENSE](LICENSE).\n\nThis project injects CKEditor 5 which is licensed under the terms of [GNU General Public License Version 2 or later](https://www.gnu.org/licenses/old-licenses/gpl-2.0.html). For more information about CKEditor 5 licensing, please see their [official documentation](https://ckeditor.com/legal/ckeditor-oss-license/).","ref":"readme.html#license"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2025 Mateusz Bagiński\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}